# coding: utf-8

"""
    Merge HRIS API

    The unified API for building rich integrations with multiple HR Information System platforms.  # noqa: E501

    The version of the OpenAPI document: 1.0
    Contact: hello@merge.dev
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from MergeHRISClient.configuration import Configuration


class Employment(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'remote_id': 'str',
        'job_title': 'str',
        'pay_rate': 'float',
        'pay_period': 'PayPeriodEnum',
        'pay_frequency': 'PayFrequencyEnum',
        'pay_currency': 'PayCurrencyEnum',
        'flsa_status': 'FlsaStatusEnum',
        'effective_date': 'datetime',
        'employment_type': 'EmploymentTypeEnum'
    }

    attribute_map = {
        'id': 'id',
        'remote_id': 'remote_id',
        'job_title': 'job_title',
        'pay_rate': 'pay_rate',
        'pay_period': 'pay_period',
        'pay_frequency': 'pay_frequency',
        'pay_currency': 'pay_currency',
        'flsa_status': 'flsa_status',
        'effective_date': 'effective_date',
        'employment_type': 'employment_type'
    }

    def __init__(self, id=None, remote_id=None, job_title=None, pay_rate=None, pay_period=None, pay_frequency=None, pay_currency=None, flsa_status=None, effective_date=None, employment_type=None, local_vars_configuration=None):  # noqa: E501
        """Employment - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._remote_id = None
        self._job_title = None
        self._pay_rate = None
        self._pay_period = None
        self._pay_frequency = None
        self._pay_currency = None
        self._flsa_status = None
        self._effective_date = None
        self._employment_type = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.remote_id = remote_id
        self.job_title = job_title
        self.pay_rate = pay_rate
        self.pay_period = pay_period
        self.pay_frequency = pay_frequency
        self.pay_currency = pay_currency
        self.flsa_status = flsa_status
        self.effective_date = effective_date
        self.employment_type = employment_type

    @property
    def id(self):
        """Gets the id of this Employment.  # noqa: E501


        :return: The id of this Employment.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Employment.


        :param id: The id of this Employment.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def remote_id(self):
        """Gets the remote_id of this Employment.  # noqa: E501

        The third-party API ID of the matching object.  # noqa: E501

        :return: The remote_id of this Employment.  # noqa: E501
        :rtype: str
        """
        return self._remote_id

    @remote_id.setter
    def remote_id(self, remote_id):
        """Sets the remote_id of this Employment.

        The third-party API ID of the matching object.  # noqa: E501

        :param remote_id: The remote_id of this Employment.  # noqa: E501
        :type: str
        """

        self._remote_id = remote_id

    @property
    def job_title(self):
        """Gets the job_title of this Employment.  # noqa: E501

        The position's title.  # noqa: E501

        :return: The job_title of this Employment.  # noqa: E501
        :rtype: str
        """
        return self._job_title

    @job_title.setter
    def job_title(self, job_title):
        """Sets the job_title of this Employment.

        The position's title.  # noqa: E501

        :param job_title: The job_title of this Employment.  # noqa: E501
        :type: str
        """

        self._job_title = job_title

    @property
    def pay_rate(self):
        """Gets the pay_rate of this Employment.  # noqa: E501

        The position's pay rate in dollars.  # noqa: E501

        :return: The pay_rate of this Employment.  # noqa: E501
        :rtype: float
        """
        return self._pay_rate

    @pay_rate.setter
    def pay_rate(self, pay_rate):
        """Sets the pay_rate of this Employment.

        The position's pay rate in dollars.  # noqa: E501

        :param pay_rate: The pay_rate of this Employment.  # noqa: E501
        :type: float
        """

        self._pay_rate = pay_rate

    @property
    def pay_period(self):
        """Gets the pay_period of this Employment.  # noqa: E501

        The time period this pay rate encompasses.  # noqa: E501

        :return: The pay_period of this Employment.  # noqa: E501
        :rtype: PayPeriodEnum
        """
        return self._pay_period

    @pay_period.setter
    def pay_period(self, pay_period):
        """Sets the pay_period of this Employment.

        The time period this pay rate encompasses.  # noqa: E501

        :param pay_period: The pay_period of this Employment.  # noqa: E501
        :type: PayPeriodEnum
        """

        self._pay_period = pay_period

    @property
    def pay_frequency(self):
        """Gets the pay_frequency of this Employment.  # noqa: E501

        The position's pay frequency.  # noqa: E501

        :return: The pay_frequency of this Employment.  # noqa: E501
        :rtype: PayFrequencyEnum
        """
        return self._pay_frequency

    @pay_frequency.setter
    def pay_frequency(self, pay_frequency):
        """Sets the pay_frequency of this Employment.

        The position's pay frequency.  # noqa: E501

        :param pay_frequency: The pay_frequency of this Employment.  # noqa: E501
        :type: PayFrequencyEnum
        """

        self._pay_frequency = pay_frequency

    @property
    def pay_currency(self):
        """Gets the pay_currency of this Employment.  # noqa: E501

        The position's currency code.  # noqa: E501

        :return: The pay_currency of this Employment.  # noqa: E501
        :rtype: PayCurrencyEnum
        """
        return self._pay_currency

    @pay_currency.setter
    def pay_currency(self, pay_currency):
        """Sets the pay_currency of this Employment.

        The position's currency code.  # noqa: E501

        :param pay_currency: The pay_currency of this Employment.  # noqa: E501
        :type: PayCurrencyEnum
        """

        self._pay_currency = pay_currency

    @property
    def flsa_status(self):
        """Gets the flsa_status of this Employment.  # noqa: E501

        The position's FLSA status.  # noqa: E501

        :return: The flsa_status of this Employment.  # noqa: E501
        :rtype: FlsaStatusEnum
        """
        return self._flsa_status

    @flsa_status.setter
    def flsa_status(self, flsa_status):
        """Sets the flsa_status of this Employment.

        The position's FLSA status.  # noqa: E501

        :param flsa_status: The flsa_status of this Employment.  # noqa: E501
        :type: FlsaStatusEnum
        """

        self._flsa_status = flsa_status

    @property
    def effective_date(self):
        """Gets the effective_date of this Employment.  # noqa: E501

        The position's effective date.  # noqa: E501

        :return: The effective_date of this Employment.  # noqa: E501
        :rtype: datetime
        """
        return self._effective_date

    @effective_date.setter
    def effective_date(self, effective_date):
        """Sets the effective_date of this Employment.

        The position's effective date.  # noqa: E501

        :param effective_date: The effective_date of this Employment.  # noqa: E501
        :type: datetime
        """

        self._effective_date = effective_date

    @property
    def employment_type(self):
        """Gets the employment_type of this Employment.  # noqa: E501

        The position's type of employment.  # noqa: E501

        :return: The employment_type of this Employment.  # noqa: E501
        :rtype: EmploymentTypeEnum
        """
        return self._employment_type

    @employment_type.setter
    def employment_type(self, employment_type):
        """Sets the employment_type of this Employment.

        The position's type of employment.  # noqa: E501

        :param employment_type: The employment_type of this Employment.  # noqa: E501
        :type: EmploymentTypeEnum
        """

        self._employment_type = employment_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Employment):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Employment):
            return True

        return self.to_dict() != other.to_dict()
