# coding: utf-8

"""
    Merge HRIS API

    The unified API for building rich integrations with multiple HR Information System platforms.  # noqa: E501

    The version of the OpenAPI document: 1.0
    Contact: hello@merge.dev
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from MergeHRISClient.configuration import Configuration


class PatchedDeduction(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'employee_payroll_run': 'str',
        'name': 'str',
        'employee_deduction': 'float',
        'company_deduction': 'float'
    }

    attribute_map = {
        'id': 'id',
        'employee_payroll_run': 'employee_payroll_run',
        'name': 'name',
        'employee_deduction': 'employee_deduction',
        'company_deduction': 'company_deduction'
    }

    def __init__(self, id=None, employee_payroll_run=None, name=None, employee_deduction=None, company_deduction=None, local_vars_configuration=None):  # noqa: E501
        """PatchedDeduction - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._employee_payroll_run = None
        self._name = None
        self._employee_deduction = None
        self._company_deduction = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.employee_payroll_run = employee_payroll_run
        self.name = name
        self.employee_deduction = employee_deduction
        self.company_deduction = company_deduction

    @property
    def id(self):
        """Gets the id of this PatchedDeduction.  # noqa: E501


        :return: The id of this PatchedDeduction.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PatchedDeduction.


        :param id: The id of this PatchedDeduction.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def employee_payroll_run(self):
        """Gets the employee_payroll_run of this PatchedDeduction.  # noqa: E501

        The deduction's employee payroll run.  # noqa: E501

        :return: The employee_payroll_run of this PatchedDeduction.  # noqa: E501
        :rtype: str
        """
        return self._employee_payroll_run

    @employee_payroll_run.setter
    def employee_payroll_run(self, employee_payroll_run):
        """Sets the employee_payroll_run of this PatchedDeduction.

        The deduction's employee payroll run.  # noqa: E501

        :param employee_payroll_run: The employee_payroll_run of this PatchedDeduction.  # noqa: E501
        :type: str
        """

        self._employee_payroll_run = employee_payroll_run

    @property
    def name(self):
        """Gets the name of this PatchedDeduction.  # noqa: E501

        The deduction's name.  # noqa: E501

        :return: The name of this PatchedDeduction.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PatchedDeduction.

        The deduction's name.  # noqa: E501

        :param name: The name of this PatchedDeduction.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def employee_deduction(self):
        """Gets the employee_deduction of this PatchedDeduction.  # noqa: E501

        The amount the employee is deducting.  # noqa: E501

        :return: The employee_deduction of this PatchedDeduction.  # noqa: E501
        :rtype: float
        """
        return self._employee_deduction

    @employee_deduction.setter
    def employee_deduction(self, employee_deduction):
        """Sets the employee_deduction of this PatchedDeduction.

        The amount the employee is deducting.  # noqa: E501

        :param employee_deduction: The employee_deduction of this PatchedDeduction.  # noqa: E501
        :type: float
        """

        self._employee_deduction = employee_deduction

    @property
    def company_deduction(self):
        """Gets the company_deduction of this PatchedDeduction.  # noqa: E501

        The amount the company is deducting.  # noqa: E501

        :return: The company_deduction of this PatchedDeduction.  # noqa: E501
        :rtype: float
        """
        return self._company_deduction

    @company_deduction.setter
    def company_deduction(self, company_deduction):
        """Sets the company_deduction of this PatchedDeduction.

        The amount the company is deducting.  # noqa: E501

        :param company_deduction: The company_deduction of this PatchedDeduction.  # noqa: E501
        :type: float
        """

        self._company_deduction = company_deduction

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PatchedDeduction):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PatchedDeduction):
            return True

        return self.to_dict() != other.to_dict()
